/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.mutate;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.constraint.ConstrainedGenotypeMap;
import org.fortiss.af3.exploration.alg.dse.sysmodel.random.RandomExploration;
import org.opt4j.core.Genotype;
import org.opt4j.operators.mutate.Mutate;

/**
 * Base class for {@link Mutate} operators that provide a random number generator.
 * 
 * @author diewald
 */
public abstract class MutateBase<T extends Genotype> implements Mutate<T> {
	/** Random generator */
	protected final RandomExploration rand = RandomExploration.getInstance();

	/** Constraint map singleton that holds the constraints for modifying {@link Genotype}s. */
	protected final ConstrainedGenotypeMap constraints;

	/** Constructor. */
	public MutateBase(ConstrainedGenotypeMap constraints) {
		this.constraints = constraints;
	}
}
