/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.service;

import org.fortiss.af3.exploration.alg.service.module.IExpSpecTransformationModule;
import org.fortiss.af3.exploration.model.ExplorationTarget;

/**
 * This service transforms a collection of input {@link ExplorationTarget}s that can be processed
 * internally by the DSE, e.g. in operators,
 * such that the DSE's efficiency can be increased. It does so by providing registered
 * {@link IExpSpecTransformationModule}s with the generic constraints for which
 * the modules were registered and collecting the transformation results of each module.
 * 
 * @author diewald
 */
public interface IExpSpecTransformationService
		extends IExpSpecTransformationModule<IExpSpecTransformationModule<?>>, IExplorationService {
	// The service is compositional w.r.t. {@link IExpSpecTransformationModule}s. Service-spefic
	// methods shall be placed here.
}
