/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.servicemodule.transform.expspec.constraint;

import java.util.Collection;
import java.util.Collections;

import org.fortiss.af3.exploration.alg.service.module.IExpSpecElementTransformator;
import org.fortiss.af3.exploration.alg.service.module.base.ExpSpecElementTransformationManager;
import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.moea.model.constraints.InternalConstraint;
import org.fortiss.tooling.kernel.introspection.IIntrospectionDetailsItem;
import org.fortiss.tooling.kernel.introspection.IIntrospectionItem;
import org.opt4j.core.problem.Decoder;

/**
 * Converts DSML-base {@link ExplorationConstraint}s to {@link InternalConstraint}s that are
 * interpreted more efficiently by the DSE. Those constraints are interpretable by {@link Decoder}s.
 * The actual transformations are performed by child {@link IExpSpecElementTransformator}s
 * 
 * @author diewald
 */
public class DSMLToInternalConstraintTransformer extends ExpSpecElementTransformationManager {

	/** {@inheritDoc} */
	@Override
	public String getIntrospectionLabel() {
		return "DSML to InternalConstraint Transformer";
	}

	/** {@inheritDoc} */
	@Override
	public boolean showInIntrospectionNavigation() {
		return true;
	}

	/** {@inheritDoc} */
	@Override
	public Collection<IIntrospectionItem> getIntrospectionItems() {
		return Collections.emptyList();
	}

	/** {@inheritDoc} */
	@Override
	public IIntrospectionDetailsItem getDetailsItem() {
		return null;
	}
}
